﻿using System;

namespace David.Academy.ProgrammingInCSharp.Labyrinth
{
	class Program
	{
		static void Main(string[] args)
		{
			// Деклариране и инициализация на лабиринта:
			// ' ' - празно пространство;
			// '#' - стена;
			// 'o' - шахта
			char[,] labyrinth =
			{
				{ '#', '#', '#', '#', '#', '#', '#', '#', '#', '#', },
				{ '#', ' ', '#', ' ', '#', ' ', ' ', ' ', ' ', '#', },
				{ '#', ' ', '#', ' ', ' ', ' ', '#', '#', ' ', '#', },
				{ '#', ' ', '#', ' ', '#', '#', '#', ' ', ' ', '#', },
				{ '#', ' ', ' ', ' ', 'o', ' ', '#', ' ', '#', '#', },
				{ '#', '#', '#', ' ', '#', ' ', ' ', ' ', 'o', '#', },
				{ '#', ' ', ' ', ' ', '#', '#', ' ', '#', '#', '#', },
				{ '#', ' ', '#', ' ', ' ', ' ', ' ', ' ', ' ', '#', },
				{ '#', '#', ' ', 'o', '#', '#', ' ', '#', ' ', '#', },
				{ '#', '#', '#', '#', '#', '#', '#', '#', '#', '#', },
			};

			// Координати на играча
			int playerX = 1;
			int playerY = 1;

			// "Безкраен цикъл" - изпълнява се, докато потребителят не пожелае прекратяването
			// му чрез натискане на Escape
			bool finishRequested = false;
			while (!finishRequested)
			{
				// Изчистване на конзолата в подготовка за извеждане на лабиринта
				Console.Clear();

				// Извеждане на лабиринта и играча в конзолата
				for (int i = 0; i < labyrinth.GetLength(0); i++)
				{
					for (int j = 0; j < labyrinth.GetLength(1); j++)
					{
						if (i == playerY && j == playerX)
							Console.Write('@');
						else
							Console.Write(labyrinth[i, j]);
					}
					Console.WriteLine();
				}

				// Ако потребителят е паднал в шахта на предишната стъпка, се извежда съобщение
				// за това и изпълнението се прекратява
				if (labyrinth[playerY, playerX] == 'o')
				{
					Console.WriteLine("Падна в шахта!");
					Console.ReadLine();
					break;
				}

				// Изчакване за натиснат клавиш:
				// При натискане на една от стрелките се прави опит за преместване в съответната псоока;
				// При натискане на Escape се отбелязва желанието на потребителя да прекрати цикъла
				switch (Console.ReadKey().Key)
				{
					case ConsoleKey.UpArrow:
						if (labyrinth[playerY - 1, playerX] != '#')
							playerY--;
						break;
					case ConsoleKey.DownArrow:
						if (labyrinth[playerY + 1, playerX] != '#')
							playerY++;
						break;
					case ConsoleKey.LeftArrow:
						if (labyrinth[playerY, playerX - 1] != '#')
							playerX--;
						break;
					case ConsoleKey.RightArrow:
						if (labyrinth[playerY, playerX + 1] != '#')
							playerX++;
						break;
					case ConsoleKey.Escape:
						finishRequested = true;
						break;
				}
			}
		}
	}
}
