﻿using System;

namespace David.Academy.ProgrammingInCSharp.Methods
{
	class Program
	{
		static void ShowTriangle(double a, double b, double c)
		{
			Console.WriteLine("a = {0}; b = {1}; c = {2}", a, b, c);
		}

		static void ShowQuadrilateral(double a, double b, double c, double d)
		{
			Console.WriteLine("a = {0}; b = {1}; c = {2}; d = {3}", a, b, c, d);
		}

		/// <summary>
		/// Намира полупериметъра на многоъгълник
		/// </summary>
		/// <param name="a">дължини на страните на многоъгълник</param>
		/// <returns>полупериметър</returns>
		/// <remarks>демонстрира използването на масив от параметри</remarks>
		static double GetSemiperimeter(params double[] a)
		{
			// първоначалната сума от страните е 0
			double sum = 0;
			for (int i = 0; i < a.Length; i++)
			{
				// увеличаваме сумата с i-тата страна
				sum = sum + a[i];
			}

			return sum / 2;
		}

		static double GetTriangleSurface(double a, double b, double c)
		{
			double p = GetSemiperimeter(a, b, c);

			double s = Math.Sqrt(p * (p - a) * (p - b) * (p - c));

			return s;
		}

		static void ShowArray(int[] arr)
		{
			for (int i = 0; i < arr.Length; i++)
				Console.Write("{0,4}", arr[i]);
			Console.WriteLine();
		}

		static void GetCourseInfo(string courseName, string organisationName, int year)
		{
			courseName = "Програмиране на C#";
			organisationName = "ДАВИД академия";
		}

		static void GetCourseInfo(ref string courseName, ref string organisationName, ref int year)
		{
			courseName = "Програмиране на C#";
			organisationName = "ДАВИД академия";
		}

		static void GetCourseInfo(int id, out string courseName, out string organisationName, out int year)
		{
			courseName = "Програмиране на C#";
			organisationName = "ДАВИД академия";
			year = 2014;
		}

		static void Main(string[] args)
		{
			#region Инициализация

			double x = 1, y = 2;
			double z = Math.Sqrt(x * x + y * y);
			double p = GetSemiperimeter(x, y, z);
			double s = GetTriangleSurface(x, y, z);

			#endregion

			#region Триъгълник

			ShowTriangle(x, y, z);
			Console.WriteLine("p = {0}; S = {1}", p, s);

			#endregion

			#region Четириъгълник

			ShowQuadrilateral(x, y, z, 1);
			Console.WriteLine("p = {0}", GetSemiperimeter(x, y, z, 1));

			#endregion

			#region Подаване на параметър като референция

			int[] arr = new int[] { 1, 3, 7, 2, 5, 12, 6, 12, 0, -5, -7 };
			ShowArray(arr);
			Array.Sort(arr);
			ShowArray(arr);

			#endregion

			string courseName = null;
			string organisationName = null;
			int year = 2013;

			// извикване с обикновени аргументи
			GetCourseInfo(courseName, organisationName, year);

			// извикване с референтни аргументи
			GetCourseInfo(ref courseName, ref organisationName, ref year);

			int year2;
			// извикване с изходни аргументи
			GetCourseInfo(5, out courseName, out organisationName, out year2);
		}
	}
}
