﻿using System;

namespace David.Academy.ProgrammingInCSharp.BinarySearch
{
	class Program
	{
		static void ShowArray(int[] a)
		{
			for (int i = 0; i < a.Length; i++)
				Console.Write(a[i] + " ");
			Console.WriteLine();
		}

		static int FindValue(int[] a, int value, int start, int end)
		{
			// не сме намерили търсената стойност
			if (end < start)
				return -1;

			// намираме ключа
			int middleIndex = (start + end) / 2;
			// намираме стойността на ключа
			int middleValue = a[middleIndex];

			// стойността, която търсим, се намира в левия подмасив
			if (value < middleValue)
				return FindValue(a, value, start, middleIndex - 1);
			// стойността, която търсим, се намира в десния подмасив
			if (value > middleValue)
				return FindValue(a, value, middleIndex + 1, end);
			// намерили сме стойността (value = middleValue)
			return middleIndex;
		}

		static void Main(string[] args)
		{
			int[] a = new[] { 7, -5, 40, 1, 34, 6, 1, -30, 14, 0 };

			Array.Sort(a);

			ShowArray(a);

			while (true)
			{
				Console.Write("value = ");
				string line = Console.ReadLine();
				if (string.IsNullOrEmpty(line))
					break;

				int value = int.Parse(line);

				int result = FindValue(a, value, 0, a.Length - 1);
				if (result < 0)
					Console.WriteLine("Sorry!");
				else
					Console.WriteLine("I found it! I found it! At {0}!", result);
			}
		}
	}
}
