﻿using System;

namespace David.Academy.ProgrammingInCSharp.Fibonacci
{
	class Program
	{
		static ulong GetFibonacciNumberRec(ulong n)
		{
			// дъно на рекурсията
			if (n == 0)
				return 1;
			if (n == 1)
				return 1;

			// две рекурсивни извиквания
			ulong a = GetFibonacciNumberRec(n - 1);
			ulong b = GetFibonacciNumberRec(n - 2);

			return a + b;
		}

		static ulong GetFibonacciNumberRec(ulong n, ulong[] lookup)
		{
			// дъно на рекурсията
			if (n == 0)
				return 1;
			if (n == 1)
				return 1;

			// връщаме записания резултат, ако имаме вече такъв
			if (lookup[n] > 0)
				return lookup[n];

			// две рекурсивни извиквания
			ulong a = GetFibonacciNumberRec(n - 1, lookup);
			ulong b = GetFibonacciNumberRec(n - 2, lookup);

			ulong result = a + b;

			// записваме си резултата в нашата lookup таблица
			//	0	1	2	3	4	5	6	7	...
			//	0	0	2	3	5	8	13	21	...
			lookup[n] = result;

			return result;
		}

		static void Main(string[] args)
		{
			for (ulong i = 1; i <= 38; i++)
			{
				Console.WriteLine("GetFibonacciNumberRec({0}) = {1}",
					i, GetFibonacciNumberRec(i));
			}

			ulong[] lookup = new ulong[100];
			for (ulong i = 1; i <= 99; i++)
			{
				Console.WriteLine("GetFibonacciNumberRec({0}, lookup) = {1}",
					i, GetFibonacciNumberRec(i, lookup));
			}

			Console.ReadLine();
		}
	}
}
