﻿using System;

namespace David.Academy.ProgrammingInCSharp.MethodsCtorsAndDtors
{
	enum Gender
	{
		Male,
		Female,
		Other,
	}

	class Person
	{
		readonly Gender _gender;
		readonly DateTime _birthDate;
		readonly GeoLocation _birthPlace;
		string _firstName;
		string _middleName;
		string _lastName;

		public Person(Gender gender)
			: this(gender, DateTime.Now, null)
		{
		}

		public Person(Gender gender, DateTime birthDate)
			: this(gender, birthDate, null)
		{
		}

		public Person(Gender gender, DateTime birthDate, GeoLocation birthPlace)
		{
			_gender = gender;
			_birthDate = birthDate;
			_birthPlace = birthPlace;
		}

		public void SetNames(string firstName, string middleName, string lastName)
		{
			_firstName = firstName;
			_middleName = middleName;
			_lastName = lastName;
		}

		public string GetFullName()
		{
			string fullName = string.Format(
				"{0} {1} {2}",
				_firstName, _middleName, _lastName);

			return fullName;
		}

		public void ShowFullName()
		{
			string fullName = GetFullName();

			Console.WriteLine(fullName);
		}

		public void Meet(Person thatPerson)
		{
			string thisPersonName = this.GetFullName();
			string thatPersonName = thatPerson.GetFullName();

			TimeSpan datAge = DateTime.Now - thatPerson._birthDate;
			TimeSpan datDifference = thatPerson._birthDate - this._birthDate;
			if (datAge < TimeSpan.FromDays(2 * 365))
				Console.WriteLine("{0}: {1}, агуууу!!",
					thisPersonName, thatPersonName);
			else if (datDifference > TimeSpan.FromDays(5 * 365))
				Console.WriteLine("{0}: {1}, къде отиваш ти, може би?!",
					thisPersonName, thatPersonName);
			else
			{
				string message = string.Format("<3 {0} + {1} = ВНЛ <3",
					thisPersonName, thatPersonName);

				Console.Write(message);
			}
		}
	}

	class GeoLocation
	{
		double _longitude, _latitude, _altitude;

		public GeoLocation(double longitude, double latitude)
		{
			_longitude = longitude;
			_latitude = latitude;
		}

		public GeoLocation(double longitude, double latitude, double altitude)
			: this(longitude, latitude)
		{
			_altitude = altitude;
		}
	}

	class Program
	{
		static void Main(string[] args)
		{
			DateTime person1bd = new DateTime(1982, 10, 8);
			Person person1 = new Person(Gender.Male, person1bd);
			person1.SetNames("Валери", "Петров", "Дачев");

			Person person2 = new Person(Gender.Female);
			person2.SetNames("Тинка", "Джонова", "Щерьова");

			// минава се някакво време...

			person1.Meet(person2);

			GeoLocation location = new GeoLocation(0, 0);
		}
	}
}
