﻿using System;

namespace David.Academy.ProgrammingInCSharp.Encapsulation
{
	/// <summary>
	/// Клас за кръг. Наследява класа Shape2D
	/// </summary>
	class Circle : Shape2D
	{
		// Частно поле за радиус на кръга
		private double _radius;

		/// <summary>
		/// Конструктор на кръга с параметър: радиус; изпълнява защитения конструктор
		/// на родителския клас със съответната стойност за лице на кръга
		/// </summary>
		/// <param name="radius">Радиус на кръга</param>
		public Circle(double radius)
			: base(Math.PI * Math.Pow(radius, 2))
		{
			// Предизвикване на грешка при изпълнение, ако е подаден неположителен радиус на кръга
			if (radius <= 0)
				throw new ArgumentException();

			_radius = radius;
		}

		/// <summary>
		/// Връща радиуса на кръга
		/// </summary>
		/// <returns>Радиус на кръга</returns>
		public double GetRadius()
		{
			return _radius;
		}

		/// <summary>
		/// Промена радиуса на кръга
		/// </summary>
		/// <param name="radius">Нов радиус на кръга</param>
		public void SetRadius(double radius)
		{
			if (radius <= 0)
				throw new ArgumentException();

			_radius = radius;
			// Преизчисляване на лицето на кръга
			SetArea(Math.PI * Math.Pow(radius, 2));
		}
	}
}
