﻿using System;

namespace David.Academy.ProgrammingInCSharp.Inheritance
{
	/// <summary>
	/// Клас за произволно небесно тяло. Базов клас за йерархията
	/// </summary>
	class CelestialBody
	{
		// Характеристики, общи за всички небесни тела: наименование, маса и разстояние от Земята
		public string Name;
		public double Mass;
		public double Distance;

		/// <summary>
		/// Конструктор без параметри
		/// </summary>
		public CelestialBody()
		{
			Console.WriteLine("CelestialBody::.ctor()");
		}

		/// <summary>
		/// Конструктор с параметър: наименование
		/// </summary>
		/// <param name="name">Наименование на небесното тяло</param>
		public CelestialBody(string name)
		{
			Console.WriteLine("CelestialBody::.ctor(name)");
			Name = name;
		}

		/// <summary>
		/// Конструктор с параметри: наименование, маса и разстояние от Земята
		/// </summary>
		/// <param name="name">Наименование на небесното тяло</param>
		/// <param name="mass">Маса на небесното тяло</param>
		/// <param name="distance">Разстояние от Земята до небесното тяло</param>
		public CelestialBody(string name, double mass, double distance)
			: this(name)
		{
			Console.WriteLine("CelestialBody::.ctor(name, mass, distance)");
			Mass = mass;
			Distance = distance;
		}

		/// <summary>
		/// Връща текстово описание на характеристиките на небесното тяло
		/// </summary>
		/// <returns>Текстово описание на характеристиките на небесното тяло</returns>
		public string GetDescription()
		{
			return string.Format("{0}, {1} tonnes, Distance: {2}", Name, Mass, Distance);
		}
	}
}
