﻿using System;

namespace David.Academy.ProgrammingInCSharp.Inheritance
{
	/// <summary>
	/// Клас за звезда. Наследява класа CelestialBody
	/// </summary>
	class Star : CelestialBody
	{
		// Характеристики, специфични за звездите: яркост, цвят и радиус
		public double Luminosity;
		public string Color;
		public double Radius;

		/// <summary>
		/// Конструктор без параметри; изпълнява конструктора без параметри на родителския клас
		/// </summary>
		public Star()
		{
			Console.WriteLine("Star::.ctor()");
		}

		/// <summary>
		/// Кара звездата да избухне в супернова
		/// </summary>
		public void GoSupernova()
		{
			Console.WriteLine("GGWP");
		}

		/// <summary>
		/// Връща текстово описание на характеристиките на звездата; използва едноименния
		/// метод на родителския клас, за да получи описание на общите за всички небесни тела
		/// характеристики
		/// </summary>
		/// <returns>Текстово описание на характеристиките на звездата</returns>
		public string GetDescription()
		{
			return string.Format(
				"{0}, Liminosity: {1}, Color: {1}, Radius: {2}km",
				base.GetDescription(),
				Luminosity,
				Color,
				Radius);
		}
	}
}
