﻿namespace Polymorphism
{
	public struct Color
	{
		public int R { get; set; }
		public int G { get; set; }
		public int B { get; set; }

		// презаписваме проверката дали е true
		public static bool operator true(Color c)
		{
			return c.R != 0 || c.G != 0 || c.B != 0;
		}

		// презаписваме проверката дали е false
		// забележка: винаги се презаписват в заедно
		public static bool operator false(Color c)
		{
			return c.R == 0 && c.G == 0 && c.B == 0;
		}

		// презаписваме смесването на ДВА цвята
		public static Color operator +(Color l, Color r)
		{
			return new Color
			{
				R = l.R + r.R,
				G = l.G + r.G,
				B = l.B + r.B,
			};
		}

		// неявно превръщане от Color към число
		public static implicit operator long(Color c)
		{
			return ((256 * c.R + c.G) * 256 + c.B);
		}

		// явно превръщане от Color към низ
		public static explicit operator string(Color c)
		{
			return string.Format("#{0:x}{1:x}{2:x}", c.R, c.G, c.B);
		}
	}

}
