﻿using System;

namespace David.Academy.ProgrammingInCSharp.Zoo
{
	class Program
	{
		static void Main(string[] args)
		{
			Zoo zoo = new Zoo("Казанлъшки национален зоопарк");

			PopulateZoo(zoo);

			Console.WriteLine("В '{0}' има {1} животни.", zoo.Name, zoo.AnimalCount);

			for (int i = 0; i < zoo.AnimalCount; i++)
			{
				// индексиране по пореден номер
				Animal animal = zoo[i];

				Console.WriteLine("№{0}. {1}", i + 1, animal);
				animal.MakeSound();
			}

			// индексиране по баркод (успешен резултат)
			Animal foundAnimal = zoo["HJAH8918372"];
			if (foundAnimal == null)
				Console.WriteLine("Това пък животно от къде го взе?!");
			else
				Console.WriteLine("Ей го/я {0}, бе!", foundAnimal.Name);

			// индексиране по баркод (неуспешен резултат)
			foundAnimal = zoo["ABCDEFGHI"];
			if (foundAnimal == null)
				Console.WriteLine("Е, няма такова животно!");
			else
				Console.WriteLine("Това ще е само {0}, бе!", foundAnimal.Name);
		}

		private static void PopulateZoo(Zoo zoo)
		{
			Plant plant = new Plant("Фикус");

			Animal cat = new Cat("HJAH8918372")
			{
				Name = "Котка",
			};
			zoo.AddAnimal(cat);

			Animal alien = new Alien("BSKAKE")
			{
				Name = "Алф",
			};
			zoo.AddAnimal(alien);

			alien.Eat(cat);

			Animal fish = new Fish("Немо");
			zoo.AddAnimal(fish);

			Animal dog = new Dog("JKAJK182")
			{
				Name = "Шаро",
			};
			zoo.AddAnimal(dog);

			dog.Eat(plant);
		}
	}
}
