﻿namespace David.Academy.ProgrammingInCSharp.Interfaces
{
	/// <summary>
	/// Интерфейс за обекти, които могат да се придвижват
	/// </summary>
	interface IMobileObject
	{
		/// <summary>
		/// Проверява дали обектът може да се придвижи до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи обектът</param>
		/// <returns>Истина, ако обектът може да се придвижи до указаната точка</returns>
		bool CanMoveTo(Point location);

		/// <summary>
		/// Придвижва обекта до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи обектът</param>
		void MoveTo(Point location);
	}
}
