﻿using System;

namespace David.Academy.ProgrammingInCSharp.Interfaces
{
	/// <summary>
	/// Клас за стелт самолет. Имплементира интерфейса IMobileObject (явно)
	/// </summary>
	class StealthPlane : IMobileObject
	{
		/// <summary>
		/// Проверява дали самолетът може да се придвижи до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи самолетът</param>
		/// <returns>Истина, ако самолетът може да се придвижи до указаната точка</returns>
		bool IMobileObject.CanMoveTo(Point location)
		{
			return true;
		}

		/// <summary>
		/// Придвижва самолета до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи самолетът</param>
		void IMobileObject.MoveTo(Point location)
		{
			Console.WriteLine("Стелт самолетът се придвижи до ({0}, {1})", location.X, location.Y);
		}
	}
}
