﻿using System;

namespace David.Academy.ProgrammingInCSharp.Interfaces
{
	/// <summary>
	/// Клас за трактор. Имплементира интерфейсите ISoundMaker и IMobileObject (неявно)
	/// </summary>
	class Tractor : ISoundMaker, IMobileObject
	{
		/// <summary>
		/// Издава звук, специфичен за трактора
		/// </summary>
		public void MakeSound()
		{
			Console.WriteLine("Пър-та-пър-та-пър-та");
		}

		/// <summary>
		/// Проверява дали тракторът може да се придвижи до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи тракторът</param>
		/// <returns>Истина, ако тракторът може да се придвижи до указаната точка</returns>
		public bool CanMoveTo(Point location)
		{
			return true;
		}

		/// <summary>
		/// Придвижва трактора до указана точка
		/// </summary>
		/// <param name="location">Точка, до която трябва да се придвижи тракторът</param>
		public void MoveTo(Point location)
		{
			Console.WriteLine("Отидох ей там: ({0}, {1})", location.X, location.Y);
		}
	}
}
