﻿using System;

namespace David.Academy.ProgrammingInCSharp.Events
{
	/// <summary>
	/// Главен клас на програмата
	/// </summary>
	class Program
	{
		/// <summary>
		/// Главна програма
		/// </summary>
		/// <param name="args">Аргументи от командния ред</param>
		static void Main(string[] args)
		{
			// Създаване на противник
			Enemy wolf = new Enemy(10);
			// Опит за присвояване на делегатен екземпляр на събитието EnemyDied на противника;
			// Предизвиква грешка при компилация, тъй като не е разрешено на събитие да бъде присвоена стойност
			//wolf.EnemyDied = Wolf_EnemyDied;
			// Закачане на обработчик за събитието EnemyDied на противника
			wolf.EnemyDied += Wolf_EnemyDied;
			// Правене на несмъртоносни щети на противника
			wolf.Damage(8);
			// Правене на смъртоносни щети на противника - събитието за смърт ще бъде предизвикано
			wolf.Damage(3);

			// Създаване на колекция от книги
			BookCollection collection = new BookCollection(2);
			// Опит за присвояване на делегатен екземпляр на събитието CollectionFilled на колекцията;
			// Предизвиква грешка при компилация, тъй като не е разрешено на събитие да бъде присвоена стойност
			//collection.CollectionFilled = Collection_CollectionFilled;
			// Закачане на обработчик на събитието CollectionFilled на колекцията
			collection.CollectionFilled += Collection_CollectionFilled;
			// Добавяне на първа книга в колекцията
			collection.AddBook(
				new Book
				{
					Title = "Hobbit",
					Author = "J. R. R. Tolkien",
				});
			// Добавяне на втора книга в колекцията - събитието за запълване на колекцията ще бъде предизвикано
			collection.AddBook(
				new Book
				{
					Title = "The Fellowship of the Ring",
					Author = "J. R. R. Tolkien",
				});

			Console.ReadLine();
		}

		/// <summary>
		/// Обработчик на събитието за смърт на противника от главната програма
		/// </summary>
		/// <param name="enemy">Противник, който е умрял</param>
		static void Wolf_EnemyDied(Enemy enemy)
		{
			Console.WriteLine("The enemy has died! You loot a shattered claw.");
			// Откачане на обработчика от събитието EnemyDied на противника
			enemy.EnemyDied -= Wolf_EnemyDied;
		}

		/// <summary>
		/// Обработчик на събитието за запълване на колекцията от книги от главната програма
		/// </summary>
		/// <param name="collection">Колекция от книги, която се е запълнила</param>
		static void Collection_CollectionFilled(BookCollection collection)
		{
			Console.WriteLine(
				"The collection contains {0} books and is full.",
				collection.Count);
			// Откачане на обработчика от събитието CollectionFilled на колекцията
			collection.CollectionFilled -= Collection_CollectionFilled;
		}
	}
}
