﻿using System;
using System.IO;

namespace David.Academy.ProgrammingInCSharp.FileIO
{
	internal class Program
	{
		private static string GetFileName(bool isExistingFileRequired)
		{
			while (true)
			{
				Console.WriteLine("Въведете име на файл:");

				string fileName = Console.ReadLine();

				bool fileExists = File.Exists(fileName);

				if (isExistingFileRequired == fileExists)
					return fileName;
			}
		}

		private static void Main(string[] args)
		{
			bool exits = false;

			BookDatabase bookDatabase = new BookDatabase();

			do
			{
				Console.WriteLine("1. Добави книга");
				Console.WriteLine("2. Покажи книгите");
				Console.WriteLine("3. Запиши книгите");
				Console.WriteLine("4. Зареди книгите");
				Console.WriteLine("5. Добави автор");
				Console.WriteLine("6. Покажи авторите");
				Console.WriteLine("7. Запиши авторите");
				Console.WriteLine("8. Зареди авторите");
				Console.WriteLine("9. Запиши БД");
				Console.WriteLine("10. Зареди БД");
				Console.WriteLine("0. Изход");
				Console.WriteLine();

				Console.Write("Изберете: ");
				string s = Console.ReadLine();

				switch (s)
				{
					case "0":
						exits = true;
						break;
					case "1":
						bookDatabase.AddBookFromKbd();
						break;
					case "2":
						bookDatabase.PrintBooks();
						break;
					case "3":
						{
							string fileName = GetFileName(false);
							bookDatabase.SaveBooksToFile(fileName);
							break;
						}
					case "4":
						{
							string fileName = GetFileName(true);
							bookDatabase.LoadBooksFromFile(fileName);
							break;
						}
					case "5":
						bookDatabase.AddAuthorFromKbd();
						break;
					case "6":
						bookDatabase.PrintAuthors();
						break;
					case "7":
						{
							string fileName = GetFileName(false);
							bookDatabase.SaveAuthorsToFile(fileName);
							break;
						}
					case "8":
						{
							string fileName = GetFileName(true);
							bookDatabase.LoadAuthorsFromFile(fileName);
							break;
						}
					case "9":
						{
							string fileName = GetFileName(false);
							bookDatabase.SaveToFile(fileName);
							break;
						}
					case "10":
						{
							string fileName = GetFileName(true);
							bookDatabase = BookDatabase.LoadFromFile(fileName);
							break;
						}
				}
			}
			while (!exits);
		}
	}
}
