﻿namespace David.Academy.ProgrammingInCSharp.OrcsAndDungeons
{
	/// <summary>
	/// Клас за чудовище
	/// </summary>
	internal class Monster : Unit
	{
		private readonly string _name;

		/// <summary>
		/// Име на чудовището
		/// </summary>
		public string Name
		{
			get { return _name; }
		}

		/// <summary>
		/// Създава екземпляр на класа за чудовище
		/// </summary>
		/// <param name="game">Игра, част от която е чудовището</param>
		/// <param name="hitPoints">Начален брой точки живот</param>
		/// <param name="damage">Щети, които нанася при атака чудовището</param>
		/// <param name="symbol">Символ за визуализация на чудовището на екрана</param>
		/// <param name="name">Име на чудовището</param>
		public Monster(Game game, int hitPoints, int damage, char symbol, string name)
			: base(game, hitPoints, damage, symbol)
		{
			_name = name;
		}

		/// <summary>
		/// Извършва действие на случаен принцип
		/// </summary>
		public virtual void PerformAction()
		{
			for (int i = 0; i < 4; i++)
			{
				Direction direction = (Direction)Game.Random.Next(4);
				if (MoveOrAttack(direction))
					break;
			}
		}
	}
}
