﻿namespace David.Academy.ProgrammingInCSharp.OrcsAndDungeons
{
	/// <summary>
	/// Клас за орк
	/// </summary>
	internal class Orc : Monster
	{
		/// <summary>
		/// Създава екземпляр на класа за орк
		/// </summary>
		/// <param name="game">Игра, част от кяото е оркът</param>
		public Orc(Game game)
			: base(game, 3, 1, 'o', "Orc")
		{
		}

		public override void PerformAction()
		{
			Player player = Game.Player;

			for (int i = 0; i < 4; i++)
			{
				Direction direction = (Direction)i;
				Point newPoint = Point.Move(direction);

				Unit unit = Game.GetTileUnit(newPoint);
				if (unit != null
					&& (unit is Player)
					&& MoveOrAttack(direction))
					return;
			}

			base.PerformAction();
		}
	}
}
