﻿using System;

namespace David.Academy.ProgrammingInCSharp.OrcsAndDungeons
{
	internal struct Point
	{
		private readonly int _x;
		private readonly int _y;

		public int X
		{
			get { return _x; }
		}

		public int Y
		{
			get { return _y; }
		}

		public Point(int x, int y)
		{
			_x = x;
			_y = y;
		}

		/// <summary>
		/// Изчислява новите координати според старите и зададена посока
		/// </summary>
		/// <param name="direction">посока на движение</param>
		public Point Move(Direction direction)
		{
			switch (direction)
			{
				case Direction.North:
					return new Point(X, Y - 1);
				case Direction.South:
					return new Point(X, Y + 1);
				case Direction.West:
					return new Point(X - 1, Y);
				case Direction.East:
					return new Point(X + 1, Y);
				default:
					throw new ApplicationException("Dafuq direction?!");
			}
		}

		public static bool operator ==(Point a, Point b)
		{
			return a.Equals(b);
		}

		public static bool operator !=(Point a, Point b)
		{
			return !a.Equals(b);
		}

		public override int GetHashCode()
		{
			// това е сравнително добър алгоритъм за генериране на хаш за точка
			int hash = 17;

			hash = hash * 23 + _x.GetHashCode();

			hash = hash * 23 + _y.GetHashCode();

			return hash;
		}

		public override bool Equals(object obj)
		{
			return obj is Point && this == (Point)obj;
		}
	}
}
